import java.applet.*;
import java.awt.*;
import java.net.*;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;

public class EX23F extends Applet
{
	Recordset recordset;
	TextArea output;
	Database db;

	public void init()
	{
		resize(540, 460);
		output = new TextArea(30, 50);
		add(output);
	}

	public void start()
	{
		OpenDatabase();
	}
		
	public void stop()
	{
		// Close the recordset and database
		recordset.Close();
		db.Close();
	}

	private boolean OpenDatabase()
	{
		URL dbURL;
		try {
			// otherwise generate it relative to the applet
			dbURL = new java.net.URL(getDocumentBase(), 
					"sample.mdb");
		}
		catch(Exception e) {
			showStatus("Error: " + e.getMessage());
			return false;
		}

		// strip "file:/" from dbURL
		String filename = dbURL.getFile().substring(1);

		// create the database engine
		_DBEngine dbengine = dao_dbengine.create();

		// create Variants that will hold parameters that 
		// will be passed to OpenDatabase
		Variant var1 = new Variant();
		Variant var2 = new Variant();
		Variant var3 = new Variant();

		// set parameters for call to OpenDatabase
		var1.putBoolean(false);
		var2.putBoolean(false);
		var3.putString("");

		// Open the database for non-exclusive access
		db = dbengine.OpenDatabase(filename,var1,var2,var3);

		// create Variants that will hold parameters that
		// will be passed to OpenDatabase
		Variant var4 = new Variant();
		Variant var5 = new Variant();

		var4.putShort(Constants.dbOpenDynaset);
		var5.putShort(Constants.dbEditAdd);

		// create the recordset
		recordset=db.OpenRecordset("select * from Programmer",
				var4, var5);

		// display all the records in this dynaset
		DisplayAllRecords();

		// give raises to the Java programmers
		GiveRaises();
		HireNewProgrammer();

		// display all the records in this dynaset
		DisplayAllRecords();

		// requery the database
		Variant var6 = new Variant();
		var6.putNull();
		recordset.Requery(var6);

		// re-display all the records in this dynaset
		DisplayAllRecords();

		return true;
	}

	private void GiveRaises()
	{
		Variant var = new Variant();
		var.putShort(Constants.dbFailOnError);

		db.Execute("update Programmer set Salary = " +
				"Salary * 2 where KnowsJava <> 0", var);

		output.appendText("\r\nRaises given: " + 
				String.valueOf(db.getRecordsAffected()) +
				"\r\n\r\n");
	}

	private void HireNewProgrammer()
	{
		Variant var = new Variant();
		var.putShort(Constants.dbFailOnError);

		String sqlStr = "insert into Programmer (FirstName, " +
			"LastName, Salary, KnowsJava, JobTitle) " +
			"values (\"Napoleon\", \"Solo\", 63000, 0, \"Lead\")";

		db.Execute(sqlStr, var);
	}

	private void DisplayAllRecords()
	{
		// create variants and assign the names of each column
		Variant varFirstName = new Variant();
		varFirstName.putString("FirstName");

		Variant varLastName = new Variant();
		varLastName.putString("LastName");

		Variant varSalary = new Variant();
		varSalary.putString("Salary");

		Variant varKnowsJava = new Variant();
		varKnowsJava.putString("KnowsJava");

		Variant varJobTitle = new Variant();
		varJobTitle.putString("JobTitle");

		// determine how many records in the recordset
		int count = recordset.getRecordCount();

		// position recordset at the first record
		recordset.MoveFirst();

		// loop through the recordset, displaying each record
		while(recordset.getEOF() == false)
		{
			// get the fields in this recordset
			Fields fields = recordset.getFields();
			_Field fld;

			// create a Variant that will hold each the value
			// read from each column
			Variant value;

			// get the LastName field
			fld = fields.getItem(varLastName);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText(value.toString() + ", ");

			// get the FirstName field
			fld = fields.getItem(varFirstName);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText(value.toString() + "\r\n");

			// get the JobTitle field
			fld = fields.getItem(varJobTitle);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText("\t" + value.toString() + "\r\n");

			// get the Salary field
			fld = fields.getItem(varSalary);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText("\t" + value.toString() + "\r\n");

			// get the KnowsJava field
			fld = fields.getItem(varKnowsJava);
			// get its value
			value = fld.getValue();
			// display the value
			Boolean knowsJava = new Boolean (value.toBoolean());
			output.appendText("\tKnows Java: " + knowsJava.toString() + "\r\n");

			recordset.MoveNext();
		}
	}
}
